unit KOLUDP;

interface
  uses Messages,KOL,WinSock,Windows;
  const WM_UDP=WM_USER+1;
type
  PUDP =^TUDP;
         TKOLUDP = PUDP;
  TUDP = object(TObj)
   public
    HostPort      : Integer;
    HostIP        : String;
    S             : TSocket;
    Error         : Integer;
    Sadr          : TSockAddr;
    Started       : Boolean;
    procedure NewInit(IP:String;Port:Integer);
    procedure Start(Handle:HWND);
    procedure CloseIt;
    procedure SendIt(Buf,IP:String);
    procedure MakeError;
  end;
  function NewKOLUDP(AParent:PControl):PUDP;
implementation

procedure TUDP.MakeError;
begin
 { case Error of
    WSANOTINITIALISED : MsgOk('      WSAStartup');
    WSAENETDOWN       : MsgOk('  ');
    WSAEADDRINUSE     : MsgOk('   ');
    WSAEFAULT         : MsgOk('  namelen    sockaddr');
    WSAEINPROGRESS    : MsgOk('    Windows Sockets');
    WSAEAFNOSUPPORT   : MsgOk('        ');
    WSAEINVAL         : MsgOk('    ');
    WSAENOBUFS        : MsgOk('   ');
    WSAENOTSOCK       : MsgOk('       ');
    WSASYSNOTREADY    : MsgOk('      ');
    WSAVERNOTSUPPORTED: MsgOk('      Windows Sockets');
    WSAEMFILE         : MsgOk('    ');
    WSAEPROTONOSUPPORT: MsgOk('  ');
    WSAEPROTOTYPE     : MsgOk('      ');
    WSAESOCKTNOSUPPORT: MsgOk('       ');
    WSAEINTR          : MsgOk('       WSACancelBlockingCall');
    WSAEACCES         : MsgOk('    ( broadcast ),         ');
    WSAENETRESET      : MsgOk('  ');
    WSAENOTCONN       : MsgOk('  ');
    WSAESHUTDOWN      : MsgOk('    shutdown ');
    WSAEWOULDBLOCK    : MsgOk('   ,       ');
    WSAEMSGSIZE       : MsgOk('    SOCK_DGRAM (   ).             Windows Sockets ');
    WSAECONNABORTED   : MsgOk(' -        ');
    WSAECONNRESET     : MsgOk('    ');
  end;}
end;

procedure TUDP.NewInit(IP:String;Port:Integer);
begin
  HostIP:=IP;
  HostPort:=Port;
  Started:=False;
end;

procedure TUDP.Start(Handle:HWND);
begin
  if (Started=True) then CloseIt;
  S:=Socket(AF_INET,SOCK_DGRAM,0);
  Error:=S;
  if S=INVALID_SOCKET then MsgOk('Socket Error!');
  Sadr.sin_family:=AF_INET;
  Sadr.sin_port:=htons(HostPort);
  Sadr.sin_addr.S_addr:=INADDR_ANY;
  Error:=bind(S,Sadr,sizeof(Sadr));
  if Error=SOCKET_ERROR then Error:=666;//MsgOk('Bind error!');
  //Error:=WSAGetLastError;
  //MakeError;
  WSAAsyncSelect (S , Handle , WM_UDP, FD_READ );
  Started:=True;
end;

procedure TUDP.CloseIt;
begin
  if Started=True then
  begin
    Error:=CloseSocket(S);
    Started:=False;
  end;
end;

procedure TUDP.SendIt(Buf,IP:String);
  Var S_out : TSockAddr;
begin
  S_out.sin_addr.S_addr:=inet_addr(PChar(IP));
  S_out.sin_port:=htons(HostPort);
  S_out.sin_family:=AF_INET;
  Error:=SendTo(S,Buf,sizeof(Buf),0,S_out,sizeof(S_out));
  Error:=WSAGetLastError;
  MakeError;
end;

function WndProcUDPParent( Sender: PControl; var Msg: TMsg; var Rslt: Integer ): Boolean;
  Var Buf: PChar; I:Integer;
begin
  Result := FALSE;
  if (Msg.message = WM_UDP) then
  if (Msg.lParam=FD_READ) then
  begin
    if recv(Msg.wParam,Buf,I,0)<>SOCKET_ERROR then
     if (I>0) then
       MsgOk(Buf);
  end;
end;

function NewKOLUDP(AParent:PControl):PUDP;
begin
  Result := PUDP(_NewCommonControl(AParent,'',WS_CHILD,False,Nil));
  AParent.AttachProc(WndProcUDPParent);
end;

end.
